//Wiznet HTML server using official C library
//RJA deriving from w5x00_http_server.c
/**
 * Copyright (c) 2021 WIZnet Co.,Ltd
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#include "Platform.h"
#include "string.h" 

#include "wizchip_conf.h"
#include "w5x00_spi.h"
#include "w5500.h"
#include "socket.h"
#include "httpParser.h"
#include "httpUtil.h"
#include "httpServer.h"

#include "w5500.c"
#include "w5x00_spi.c"
#include "wizchip_conf.c"
#include "socket.c"
#include "httpParser.c"
#include "httpUtil.c"
#include "httpServer.c"



/* Buffer */
#define ETHERNET_BUF_MAX_SIZE (1024 * 2)

/* Socket */
#define HTTP_SOCKET_MAX_NUM 4

/**
 * ----------------------------------------------------------------------------------------------------
 * Variables
 * ----------------------------------------------------------------------------------------------------
 */
 /* Network */  //RJA:  This kind of structure initializion isn't currently working in FlexC, doing it manually below
static wiz_NetInfo g_net_info; /* =
{
    .mac = {0x00, 0x08, 0xDC, 0x12, 0x34, 0x56}, // MAC address
    .ip = {192, 168, 1, 2},                     // IP address  192.168.1.2
    .sn = {255, 255, 255, 0},                    // Subnet Mask
    .gw = {192, 168, 1, 1}, //RJA {192, 168, 11, 1},                     // Gateway
    .dns = {192, 168, 1, 1}, //RJA {8, 8, 8, 8},                         // DNS server
    .dhcp = NETINFO_STATIC  //NETINFO_DHCP //RJA                      // DHCP enable/disable
};
*/

/* HTTP */
static uint8_t g_http_send_buf[ETHERNET_BUF_MAX_SIZE] = {
    0,
};
static uint8_t g_http_recv_buf[ETHERNET_BUF_MAX_SIZE] = {
    0,
};
static uint8_t g_http_socket_num_list[HTTP_SOCKET_MAX_NUM] = { 0, 1, 2, 3 };




void Setup()
{

}

void Loop()
{
    printf("Loop...\n", f);
}




int main()
{

    printf("Starting\n");
    g_net_info.mac[0] = 0x00;
    g_net_info.mac[1] = 0x08;
    g_net_info.mac[2] = 0xDC;
    g_net_info.mac[3] = 0x12;
    g_net_info.mac[4] = 0x34;
    g_net_info.mac[5] = 0x56;
    g_net_info.ip[0] = 192;
    g_net_info.ip[1] = 168;
    g_net_info.ip[2] = 1;
    g_net_info.ip[3] = 2;
    g_net_info.sn[0] = 255;
    g_net_info.sn[1] = 255;
    g_net_info.sn[2] = 255;
    g_net_info.sn[3] = 0;
    g_net_info.gw[0] = 192;
    g_net_info.gw[1] = 168;
    g_net_info.gw[2] = 1;
    g_net_info.gw[3] = 1;
    g_net_info.dns[0] = 192;
    g_net_info.dns[1] = 168;
    g_net_info.dns[2] = 1;
    g_net_info.dns[3] = 1;
    g_net_info.dhcp = NETINFO_DHCP; //RJA  NETINFO_STATIC;  //NETINFO_DHCP //RJA                      // DHCP enable/disable

    printf(" IP          : %d.%d.%d.%d\n", g_net_info.ip[0], g_net_info.ip[1], g_net_info.ip[2], g_net_info.ip[3]);

    Setup();

    /* Initialize */
    uint8_t i = 0;

    printf("wizchip_spi_initialize\n");
    wizchip_spi_initialize();
    printf("wizchip_cris_initialize\n");
    wizchip_cris_initialize();

    printf("wizchip_reset\n");
    wizchip_reset();
    printf("wizchip_initialize\n");
    wizchip_initialize();
    printf("wizchip_check\n");
    wizchip_check();
    printf("Check complete.");

    network_initialize(g_net_info);
    
    //RJA FlexC didn't seem to initialize these correctly:
    g_http_socket_num_list[0] = 0;
    g_http_socket_num_list[1] = 1;
    g_http_socket_num_list[2] = 2;
    g_http_socket_num_list[3] = 3;

    httpServer_init(g_http_send_buf, g_http_recv_buf, HTTP_SOCKET_MAX_NUM, g_http_socket_num_list);  

    /* Get network information */
   print_network_information(g_net_info);
   printf("starting register.\n");

    /* Register web page */
   reg_httpServer_webContent("index.html", index_page);

    /* Infinite loop */
    while (1)
    {
        /* Run HTTP server */
        for (i = 0; i < HTTP_SOCKET_MAX_NUM; i++)
        {
            httpServer_run(i);
        }
    }

 


}
